									(* recolleur de gnome : fichier d'aides *)

(* 	Les brins d'ADN se rencontrent sous forme d'une pelotte, un fil de ~2 mtres de long y est enroul. Pour les tudier il faut commencer par les drouler, ce faisant ... il y a des accidents de manipulation et on les casse. Ci-dessous un morceau de longueur N est 
	cass en K ..... si on n'a que cela on a (pour k=4) 24*16 = 384 possibilits de brins initiaux
	
		Ci-dessous on suppose que le mme brin a t cass deux fois, on est donc sr de pouvoir trouver au moins deux r-arrangements possibles. On veut les trouver tous 

		Un algorithme joyeux consiste  fabriquer les M=384 brins possibles pour chacun de nos K-uplets. Puis on fait les 384 = 147456 comparaisons ... le fait que leur longueur soit N n'est mme plus le point important	! 
		
		En tant un peu plus malin, au lieu de tous les comparer, on peut les trier, puis comparer par exemple par fusion : le cot sera  ~ 2 M ln(M)
*)
																
type ADN=A|T|C|G;;
let N=100;;		(* la longueur du morceau complet *)
let K=4;;			(* le nombre de morceaux aprs cassures *)

#open "random";; #open "sort";;

(* la premire chose est de savoir se fabriquer des exemples  traiter *)

(* des utilitaires pour les tirages au sort *)
(* la fonction  tirage_a_permutation va rpartir alatoirement les k entiers 0..(k-1) dans un vecteur. L'ide est de travailler avec de string : on place 1 seul "au centre". Puis on insre 2 soit  droite, soit  gauche selon le rsultat d'un int 1, puis on insre 3 en position 0, 1 ou 2 selon le rsultat d'un int 3....
	Une permutation est ainsi code par un tableau [|m(2);...m(n)|]
	
Note1 : il s'agit de l'criture des entiers en "base factorielle"
Note2 : si on travaille avec des entiers de 0..9, la technique d'insertion par chane de caractres s'impose, hls caml n'a pas de "insert" tout prt pour les string, l'exprience m'ayant dj fait perdre 17 fois 1/2 heure  apprendre les commandes de string, je vais travailler en listes       *)

(* installe nb liste place va installer "nb"  la place" place" dans la liste "liste"
installe 17 [4;5;6;7;8;9] 3  		donne 
- : int list = [4; 5; 6; 17; 7; 8; 9]			*)

let installe nb liste place=
	************************************************
(* tirage() donne le codage d'une permutation de K lments en base factorielle (dfinition donne dans le  prcdent). ci dessous un exemple avec k=4
tirage() 							donne
- : int vect = [|0; 0; 1|]						 *)

let tirage()=
	************************************************

(* tirage_a_permutation() donne le codage "usuel" d'une permutation de 1..K en utilisant tirage() et une liste dans laquelle on insre  rptition 			
#tirage_a_permutation();;					donne
- : int vect = [|3; 4; 1; 2|]										 *)
let tirage_a_permutation()=
	************************************************
		
(* trois utilitaires minuscules :
					dedouble		flatten		dieu 
					
dedouble [|7;8;5;1|];;		- : int list * int list = [7; 8; 5; 1], [1; 5; 8; 7]
flatten [(8,9);(7,10)];;		- : int list = [8; 9; 7; 10]			
map dieu [();();();();();();();();();();();();()];;  
								- : ADN list = [A; A; C; G; A; G; T; C; C; C; A; G; C]		 *)
let dedouble x = 
	************************************************
let rec flatten =
	************************************************	
let dieu() =
	************************************************
		
		(*  *)
(* la fonction test va crer la liste de 100 trucs  couper et  recoller *)
				
let test = 
************************************************	

(* la fonction cassures va fournir 3 entiers : des emplacements de cassure pour le brin d'ADN, ce seront 3 entiers de 1..100 mais pas vraiment au hasard on veut des bons bouts d'brins de longueurs au moins 5 
		par exemple : - : int vect = [|26; 53; 79|] *)
			
let cassures () = 
************************************************	
************************************************	
************************************************	
************************************************	
************************************************	
************************************************	

(* la fonction morceaux va fournir une liste 4 brins : ils seront issus du brin d'origine par l'usage de la fonction cassure() puis mis dans le dsordre et ventuellement retourns 
	vous avez un chantillon en papier  *)
let morceaux () = 
************************************************	
************************************************	
************************************************	
************************************************	
************************************************	
************************************************	
************************************************	
************************************************	

(* pour fabriquer un exercice pour se mettre en route :			*)		
let p=morceaux();;
let s=morceaux();;

(* Test " la main" *)
(* On est parti de deux exemplaires d'un mme vecteur de longueur 100 form de A,C,G,T
	chacun des deux a t coup en 4 morceaux de longueurs au moins 5
	les morceaux se sont peut-tre retourns
	
	Il faut trouver un (tous!?!) les moyens de reconstituer une liste de longueur 100 qui ait pu donner naissance  ces deux quadruplets *)	
	
(* premier quadruplet : P, second : S *)
let p_vrac= 	let vrac=tirage_a_permutation() and vp = (vect_of_list p)
					in 	map_vect (function i->vp.(vrac.(i-1)-1)) [|1;2;3;4|]  ;;
					
let s_vrac= 	let vrac=tirage_a_permutation() and vp = (vect_of_list s)
					in 	map_vect (function i->vp.(vrac.(i-1)-1)) [|1;2;3;4|] ;;
     
(* pour les manipulations  la main : p_vrac_liste et q_vrac_liste  *)       
let pvl=map_vect list_of_vect p_vrac;;
let svl=map_vect list_of_vect s_vrac;;

  (* nombre  priori de possibilits : 24*16 pour chaque  soit 147456 				*)  
(* parmi les 8 extrmits de P et les 8 de S se trouvent ncssairement les extrmits du vecteur de dpart. 
S'il n'y a pas de coincidences il faudra associer ces deux couples. Partant de l, s'il n'y a pas de coincidence, on aura un reliquat de longueur qui sera "uniquement" un autre dbut, et on continue ainsi
S'il y a coincidence, on fait pareil pour chacun des cas *)  

let p_debut=flatten (list_of_vect (map_vect dedouble p_vrac));;
let s_debut=flatten (list_of_vect  (map_vect dedouble s_vrac));;

(* on commence par crire une fonction qui prend deux listes et dit si l'une est le dbut de l'autre. 
		Dans le type rponse on peut avoir E(gal, P(remier, S(econd, Non
		L'entier qui suit donne la longueur du bout qui dpasse   *)		

type reponse = E|P|S|Non;;

let rec inclus = fun
	|[] [] 	->	 E,0
	|[] l	->	 P,(list_length l)
	|l []	->	 S,(list_length l)
	|(t1::q1) (t2::q2)	->	if t1=t2
								then inclus q1 q2 
								else  Non,0;;		

(*		inclus  [5;6] [5;6;7];;
inclus  [5;6;7;8;9;10] [5;6;7];;				
inclus  [5;6;7;8;9] [5;6;7;8;9];;				
inclus  [5;6;7;8;9] [4;5;6;7;8;9];;
	- : reponse * int = P, 1
#- : reponse * int = S, 3
#- : reponse * int = E, 0
#- : reponse * int = Non, 0			*)

let bimap f l1 l2=map (function x-> map (f x) l2) l1;;
let rec colle =  function  |[] -> []  |t::q -> t@(colle q);;	
colle (bimap inclus p_debut s_debut);;

let contenu1 l1 l2 = let (a,b)=(inclus l1 l2) in match a with
		|P	->	[a,b,l1,l2] |S -> 	[a,b,l1,l2] |_ -> [];;
		
colle (bimap contenu p_debut s_debut);;
		
(* retire servira quand on aura match des bouts de liste,  enlever ledits bouts ET leurs symtriques *)
	
let retire x liste= 
	let rx = rev x in
	let rec retir = function
		|[]		->	[] 	
		|t::q	->	if t=x or t=rx 
				then retir q
				else t::(retir q)
	in retir liste
;;											

let contenu2 l1 l2 liste_p liste_s= let (a,b)=(inclus l1 l2) in match a with
		|P	->	[a,b,l1,l2,retire l1 liste_p,retire l2 liste_s] 
		|S -> [a,b,l1,l2,retire l1 liste_p,retire l2 liste_s] 
		|_ -> [];;					

colle (bimap (fun a b -> contenu2 a b p_debut s_debut) p_debut s_debut);;

let rec vire_vide = function
	|[]		->		[]
	|t::q	->		if t=[] 
					then vire_vide q
					else t::(vire_vide q);;	

(* A un instant typique, "gnrique", on aura une liste de 		
							(Lettre,Longueur,debut_p,debut_s,reste_p,reste_s) 	
				o debut_p et debut_q ont un dbut commun
				si Lettre=P : c'est dbut_p qui est le plus court et dbut_s dpasse de Longueur							
				si Lettre=S : c'est dbut_s qui est le plus court et dbut_p dpasse de Longueur							
				si Lettre=E : dbut_p = dbut_q							*)							

(* Au lieu d'laborer un arbre de travail, il est plus malin de coder l'tat de son travail
On avait au dpart p1 ...p8 et q1...q8
	un instant sera cod par ([3;1],[7;2;1]) pour indiquer qu'en l'tat du travail on a emboit p3+p1	et q7+q2+q1 qui commencent pareil
	si on est alors dans un tat S on va chercher le bout de q  mettre au bout (il n'en reste plus que 2), si on y arrive c'est bon, sinon on va (rcursivement) retirer le dernier brin que	l'on a install pour passer au suivant *)		
				
(*  l'exemple "manuel"  *)
(*  p_vrac : ADN vect vect = 

 [|[|C; C; T; G; T; G; C; T; A; A; A; T; C; C; C; C; T; T; C; G; A; A; T; G;
     T; T; A|];
   [|C; C; C; T; T; C; G; C; A; A; C; C; T; C; T; T; T; G; G; A; G; A; G; T;
     G; G; A; G; T; A; C; A; T; C; A; G; G; T; G; A; A; G|];
   [|A; A; A; T; G|];
   [|C; T; C; A; G; T; T; A; A; A; A; T; C; T; T; G; A; C; G; T; G; A; A; C;
     A|]|]

 s_vrac : ADN vect vect = 

 [|[|G; T; A; A; A; A; C; A; A; G; T; G; C; A; G; T; T; C; T; A; A; A; A; T;
     T; G; A; C; T; C; G; A; A; G|];
   [|G; C; A; A; C; C; T|];
   [|C; C; T; G; T; G; C; T; A; A; A; T; C; C; C; C; T; T; C; G; A; A; T; G;
     T; T; A; C; C; C; T; T; C|];
   [|C; T; T; T; G; G; A; G; A; G; T; G; G; A; G; T; A; C; A; T; C; A; G; G;
     T|]|]

(* le rsultat sur cet exemple 

(rev pvl.(2))@(rev pvl.(3))@(rev pvl.(1))@(rev pvl.(0));;
(qvl.(0))@(rev qvl.(3))@(rev qvl.(1))@(rev qvl.(2));;
- : ADN list =
 [G; T; A; A; A; A; C; A; A; G; T; G; C; A; G; T; T; C; T; A; A; A; A; T; T;
  G; A; C; T; C; G; A; A; G; T; G; G; A; C; T; A; C; A; T; G; A; G; G; T; G;
  A; G; A; G; G; T; T; T; C; T; C; C; A; A; C; G; C; T; T; C; C; C; A; T; T;
  G; T; A; A; G; C; T; T; C; C; C; C; T; A; A; A; T; C; G; T; G; T; C; C]
#- : ADN list =
 [G; T; A; A; A; A; C; A; A; G; T; G; C; A; G; T; T; C; T; A; A; A; A; T; T;
  G; A; C; T; C; G; A; A; G; T; G; G; A; C; T; A; C; A; T; G; A; G; G; T; G;
  A; G; A; G; G; T; T; T; C; T; C; C; A; A; C; G; C; T; T; C; C; C; A; T; T;
  G; T; A; A; G; C; T; T; C; C; C; C; T; A; A; A; T; C; G; T; G; T; C; C]			 *)
  



